/*****************************************************************************/
/*       (C) 1993,1994 R. NADE - M. GRANDCHAMP - All Rights Reserved         */
/*****************************************************************************/
/*    This source-code is NOT public domain nor Freeware, this is part of    */
/*              'The C Programming Package' which is Shareware.              */
/*   If you use this code, please register and get a free Full-VGA version   */
/*****************************************************************************/
                            /*----------------*
                             *   CPPLMEN4.C   *
                             * Menu manager4  *
                             *----------------*/

 /* Included Files */
 # include <stdio.h>
 # include <io.h>
 # include <dos.h>
 # include <fcntl.h>
 # include <bios.h>
 # include <stdlib.h>
 # include <conio.h>

 /* Global Variables */
 extern int bm,i,j,k,l,m,n,t,x,x1,x2,xm,y,y1,y2,ym,z,menu0,menu4,return1;
 extern int colour1,colour2,colour3,colour4,colour5,returning;
 extern unsigned char c0,c1,trashcan[];

 /*----------------------*
  * CHOICE DISPLAY HELP4 *
  *----------------------*/
  void choice_display_help4()
    {
      /* We display the help that concerns the line on */
      /* which is the menu cursor (in red).            */
      if(menu4==1){
	/*  */
        display_help("MENU4   ",35,2,1);     restore_help_screen();
      }
      if(menu4==2){
	/*  */
        display_help("MENU4   ",36,3,1);     restore_help_screen();
      }
      if(menu4==3){
	/*  */
        display_help("MENU4   ",37,4,1);     restore_help_screen();
      }
      if(menu4==4){
	/*  */
        display_help("MENU4   ",38,5,1);     restore_help_screen();
      }
      if(menu4==5){
	/*  */
        display_help("MENU4   ",39,6,1);     restore_help_screen();
      }
      if(menu4==6){
	/*  */
        display_help("MENU4   ",40,7,1);     restore_help_screen();
      }
      if(menu4==7){
        /* available */
        display_help("MENU4   ",41,8,1);     restore_help_screen();
      }
      if(menu4==8){
	/*  */
        display_help("MENU4   ",42,9,1);     restore_help_screen();
      }
      if(menu4==9){
	/*  */
        display_help("MENU4   ",43,10,1);    restore_help_screen();
      }
      if(menu4==10){
	/* */
        display_help("MENU4   ",44,11,1);    restore_help_screen();
      }
    }
 /*----------------*
  * GET THE MOUSE4 *
  *----------------*/
  int get_the_mouse4()
    {
      /* If we choose with the mouse */
      /* Only available for menu 1   */
      if(ym==1){
        /* We clicked on the first line, certainly */
        /* To change of menu.                           */
        x=get_the_mouse0();
	menu0=x;                       return(-2);
      }
      if((xm>23)&&(xm<40)){
	if(ym==3){
	  /*  */
	  menu4=1;	               return(1);
	}
	if(ym==4){
	  /*  */
	  menu4=2;                     return(1);
	}
	if(ym==5){
	  /*  */
	  menu4=3;                     return(1);
	}
	if(ym==6){
	  /*  */
	  menu4=4;                     return(1);
	}
	if(ym==7){
	  /*  */
	  menu4=5;                     return(1);
	}
	if(ym==8){
	  /*  */
	  menu4=6;                     return(1);
	}
	if(ym==9){
	  /*  */
	  menu4=7;                     return(1);
	}
	if(ym==10){
	  /*  */
	  menu4=8;                     return(1);
	}
	if(ym==11){
	  /*  */
	  menu4=9;                     return(1);
	}
	if(ym==12){
	  /*  */
	  menu4=10;                    return(1);
	}
      }
      /* If we clicked outside the menu zone            */
      /* we want to erase the menu and return to menu 0 */

      menu0=0;                         return(-2);
    }
 /*--------------*
  * MENU CHOICE4 *
  *--------------*/
  int menu_choice4()
    {
      returning=wait_for_a_key();
      /* Else we pressed a keyboard key                            */
      /* Cf CPPLTC2.C for the keyboard test and the returned codes */
      if(returning==-1){
        /* <Esc> we want to go back to menu0 */
	menu0=0;                       return(-2);
      }
      if(returning==40){
        /* <Enter> execute the command */
	return(1);
      }
      if(returning==100){
        /* We pressed a mouse button */
        m=get_the_mouse4();  return(m);
      }
      /* The key letters depends on the menu  */

      /* So the below returns need to be modified */
      if(returning==24){
	/* <O> <o>  */
	menu4=1;                       return(1);
      }
      if(returning==23){
	/* <N> <n>  */
	menu4=2;                       return(1);
      }
      if(returning==28){
	/* <S> <s>  */
	menu4=3;                       return(1);
      }
      if(returning==13){
	/* <D> <d>  */
	menu4=5;                       return(1);
      }
      if(returning==27){
	/* <R> <r>  */
	menu4=6;                       return(1);
      }
      if(returning==18){
	/* <I> <i>  */
	menu4=7;                       return(1);
      }
      if(returning==15){
	/* <F> <f>  */
	menu4=8;                       return(1);
      }
      if(returning==26){
	/* <Q> <q>  */
	menu4=10;	               return(1);
      }
      /* For the 2-bytes coded keys, this is the second byte */
      if(returning==59){
         /* Function key <F1> = help */
	 return(59);
      }
      if(returning>100){
        /* We pressed Alt + another key to get a menu */
        c1=returning-100;                 k=get_special_menu00();
	if(k>0)                        return(-2);
      }
      if((returning==77)||(returning==75)){
        /* Left or Right arrow to change of menu */
        c1=returning;                             k=get_special_menu00();
	if(k>0)                        return(-2);
      }
      if(returning==72){
        /* Up arrow */
	if(menu4>1)                    menu4--;
	else                           menu4=10;
	return(0);
      }
      if(returning==80){
        /* Down arrow */
	if(menu4<10)                   menu4++;
	else                           menu4=1;
	return(0);
      }
      /* Else we return 0 = no choice */
      return(0);
    }
 /*--------------------*
  * DISPLAY LINE menu4 *
  *--------------------*/
  void display_menu_line4()
    {
      /* First we display the chosen menu0 */
      textattr(colour5);
      gotoxy(25,1);                    cputs("  Menu4  ");
      /* Same thing for the selected line */
      if(menu4==1){
	gotoxy(24,3);                  cputs("                ");
      }
      if(menu4==2){
	gotoxy(24,4);                  cputs("                ");
      }
      if(menu4==3){
	gotoxy(24,5);                  cputs("                ");
      }
      if(menu4==4){
	gotoxy(24,6);                  cputs("                ");
      }
      if(menu4==5){
	gotoxy(24,7);                  cputs("                ");
      }
      if(menu4==6){
	gotoxy(24,8);                  cputs("                ");
      }
      if(menu4==7){
	gotoxy(24,9);                  cputs("                ");
      }
      if(menu4==8){
	gotoxy(24,10);                 cputs("                ");
      }
      if(menu4==9){
	gotoxy(24,11);                 cputs("                ");
      }
      if(menu4==10){
	gotoxy(24,12);                 cputs("                ");
      }
    }
 /*----------------------*
  * DISPLAY KEY LETTER 4 *
  *----------------------*/
  void display_key_letter4()
    {
      textattr(116);
      gotoxy(25,3);                   cputs(" ");
      gotoxy(25,4);                   cputs(" ");
      gotoxy(25,5);                   cputs(" ");
      gotoxy(25,6);                   cputs(" ");
      gotoxy(25,7);                   cputs(" ");
      gotoxy(25,8);                   cputs(" ");
      gotoxy(25,9);                   cputs(" ");
      gotoxy(25,10);                  cputs(" ");
      gotoxy(25,11);                  cputs(" ");
      gotoxy(25,12);                  cputs(" ");
    }
 /*---------------*
  * DISPLAY menu4 *
  *---------------*/
  void display_menu4()
    {
      /* To avoid the trace of the previous mouse position */
      /* we hide it during the display,                    */
      /* and show it when the line has been displayed.     */
      hide_the_mouse();               textattr(colour2);
      gotoxy(22,2);                    cputs(" Ŀ ");
      gotoxy(22,3);                    cputs("                  ");
      gotoxy(22,4);                    cputs("                  ");
      gotoxy(22,5);                    cputs("                  ");
      gotoxy(22,6);                    cputs("                  ");
      gotoxy(22,7);                    cputs("                  ");
      gotoxy(22,8);                    cputs("                  ");
      gotoxy(22,9);                    cputs("                  ");
      gotoxy(22,10);                   cputs("                  ");
      gotoxy(22,11);                   cputs("                  ");
      gotoxy(22,12);                   cputs("                  ");
      gotoxy(22,13);                   cputs("  ");
      display_key_letter4();           display_menu_line4();
      show_the_mouse();
    }
 /*----------------*
  * MENU MANAGER 4 *
  *----------------*/
  int menu_manager4()
    {
      restore_screen();                return1=0;
      while(1){
        display_menu4();               return1=menu_choice4();
        if(return1==-2)                return(-2);
        if(return1==-1)                return(-1);
        if(return1==22)                choice_display_help4();
        display_menu4();
        if(return1==1){
          /* We execute the selected function */
	  if(menu4==10){
            /* We want to quit the sub-program */
	    return(-1);
	  }
	  if(menu4==1){
	    /*  */

	  }
	  if(menu4==2){
	    /*  */

	  }
	  if(menu4==3){
	    /*  */

	  }
	  if(menu4==4){
	    /*  */

	  }
	  if(menu4==5){
	    /*  */

	  }
	  if(menu4==6){
	    /*  */

	  }
	  if(menu4==7){
	    /*  */

	  }
	  if(menu4==8){
	    /*  */

	  }
	  if(menu4==9){
	    /*  */

	  }
	}
      }
    }
/* End of the Module *//*----------------*/
